//求幂函数的验证
//要点：
   //函数 int power_by_mul( int const x, int const y) 计算x 的y 次幂
//关键字：逻辑函数，数值溢出，异常退出

#include <limits.h>
#include <stdlib.h>

///////////////////////////////////////全局逻辑定义和声明////////////////////////////////////////////
/*@
logic integer power(integer m,integer n) =    //逻辑函数power 计算m 的n 次幂
    n == 0 ? 1 : m * power(m,n-1);
*/

/////////////////////////////////////power_by_mul函数的验证///////////////////////////////////////
//函数协议：
//前条件：给出x 和y 的取值范围；后条件：函数的返回值等于x 的y 次幂。
//计算溢出时程序异常退出，状态值为1。

/*@
  requires
      0 <= y < INT_MAX && 0 < x < INT_MAX
      ;
  exits \exit_status == 1;
  ensures
      \result == power(x,y)
      ;
*/
int power_by_mul( int const x, int const y)
{
    int z=1;
    int i;
    /*@
      loop invariant
          z == power(x,i) && 0 <= i <= y
          && y < INT_MAX && 0 < x < INT_MAX
          && z > 0
          ;
    */
    for(i=0; i<y; i=i+1){
        if (INT_MAX/z > x){
            z=z*x;
        }else{
            exit(1);
        }
    }
    return z;
}
